import { Buff, Bytes } from '@cmdcode/buff-utils';
import { Field, Point } from './ecc.js';
import { getXOnlyPub } from './utils.js';
import { SignerConfig } from './schema/types.js';
export declare class SecretKey extends Uint8Array {
    static random(opt?: Partial<SignerConfig>): SecretKey;
    readonly config: SignerConfig;
    constructor(secret: Bytes, options?: Partial<SignerConfig>);
    get buff(): Buff;
    get raw(): Uint8Array;
    get hex(): string;
    get field(): Field;
    get point(): Point;
    get pub(): PublicKey;
    get hasEvenY(): boolean;
    get hasOddY(): boolean;
    get xcheck(): SecretKey;
    add(bytes: Bytes): SecretKey;
    sub(bytes: Bytes): SecretKey;
    mul(bytes: Bytes): SecretKey;
    div(bytes: Bytes): SecretKey;
    pow(bytes: Bytes): SecretKey;
    negate(): SecretKey;
    sign(message: Bytes, options?: Partial<SignerConfig>): Buff;
    verify(signature: Bytes, message: Bytes, options?: Partial<SignerConfig>): boolean;
    toWIF(prefix?: number): string;
}
export declare class PublicKey extends Uint8Array {
    static random(opt?: Partial<SignerConfig>): PublicKey;
    static fromSecret(bytes: Bytes, opt?: Partial<SignerConfig>): PublicKey;
    static xfilter: typeof getXOnlyPub;
    readonly config: SignerConfig;
    constructor(pubkey: Bytes, options?: Partial<SignerConfig>);
    get buff(): Buff;
    get raw(): Uint8Array;
    get hex(): string;
    get point(): Point;
    get x(): Buff;
    get y(): Buff;
    get hasEvenY(): boolean;
    get hasOddY(): boolean;
    add(key: Bytes | PublicKey): PublicKey;
    sub(key: Bytes | PublicKey): PublicKey;
    mul(key: Bytes | PublicKey): PublicKey;
    negate(): PublicKey;
    verify(signature: Bytes, message: Bytes, options?: Partial<SignerConfig>): boolean;
}
export declare const KeyPair: typeof SecretKey;
//# sourceMappingURL=keypair.d.ts.map